/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/DataArrayResponse.h>

using namespace std;
using namespace activemq;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for DataArrayResponse
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
DataArrayResponse::DataArrayResponse()
{
}

////////////////////////////////////////////////////////////////////////////////
DataArrayResponse::~DataArrayResponse()
{
    for( size_t idata = 0; idata < data.size(); ++idata ) {
        delete data[idata];
    }
}

////////////////////////////////////////////////////////////////////////////////
DataArrayResponse* DataArrayResponse::clone() const {
    DataArrayResponse* dataArrayResponse = new DataArrayResponse();

    // Copy the data from the base class or classes
    Response::copy( dataArrayResponse );

    for( size_t idata = 0; idata < data.size(); ++idata ) {
        dataArrayResponse->getData().push_back( 
            this->data[idata]->clone();
    }

    return dataArrayResponse
}

////////////////////////////////////////////////////////////////////////////////
void DataArrayResponse::copy( DataArrayResponse* dest ) const {

    // Copy the data from the base class or classes
    Response::copy( dataArrayResponse );

    for( size_t idata = 0; idata < data.size(); ++idata ) {
        dest->getData().push_back( 
            this->data[idata]->clone() );
    }
}

////////////////////////////////////////////////////////////////////////////////
unsigned char DataArrayResponse::getDataStructureType() const {
    return DataArrayResponse::ID_DATAARRAYRESPONSE; 
}

////////////////////////////////////////////////////////////////////////////////
const std::vector<DataStructure*> DataArrayResponse::getData() const {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
std::vector<DataStructure*> DataArrayResponse::getData() {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
void DataArrayResponse::setData(std::vector<DataStructure*> data ) {
    this->data = data;
}

