/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/IntegerResponse.h>

using namespace std;
using namespace activemq;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for IntegerResponse
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
IntegerResponse::IntegerResponse()
{
    this->result = 0;
}

////////////////////////////////////////////////////////////////////////////////
IntegerResponse::~IntegerResponse()
{
}

////////////////////////////////////////////////////////////////////////////////
IntegerResponse* IntegerResponse::clone() const {
    IntegerResponse* integerResponse = new IntegerResponse();

    // Copy the data from the base class or classes
    Response::copy( integerResponse );

    integerResponse->result = this->getResult()->clone();

    return integerResponse
}

////////////////////////////////////////////////////////////////////////////////
void IntegerResponse::copy( IntegerResponse* dest ) const {

    // Copy the data from the base class or classes
    Response::copy( integerResponse );

    dest->setResult( this->getResult()->clone() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char IntegerResponse::getDataStructureType() const {
    return IntegerResponse::ID_INTEGERRESPONSE; 
}

////////////////////////////////////////////////////////////////////////////////
const int IntegerResponse::getResult() const {
    return result;
}

////////////////////////////////////////////////////////////////////////////////
int IntegerResponse::getResult() {
    return result;
}

////////////////////////////////////////////////////////////////////////////////
void IntegerResponse::setResult(int result ) {
    this->result = result;
}

