/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/PartialCommand.h>

using namespace std;
using namespace activemq;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for PartialCommand
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
PartialCommand::PartialCommand()
{
    this->commandId = 0;
}

////////////////////////////////////////////////////////////////////////////////
PartialCommand::~PartialCommand()
{
}

////////////////////////////////////////////////////////////////////////////////
PartialCommand* PartialCommand::clone() const {
    PartialCommand* partialCommand = new PartialCommand();

    // Copy the data from the base class or classes
    BaseDataStructure::copy( partialCommand );

    partialCommand->commandId = this->getCommandId()->clone();
    partialCommand->data = this->getData()->clone();

    return partialCommand
}

////////////////////////////////////////////////////////////////////////////////
void PartialCommand::copy( PartialCommand* dest ) const {

    // Copy the data from the base class or classes
    BaseDataStructure::copy( partialCommand );

    dest->setCommandId( this->getCommandId()->clone() );
    dest->setData( this->getData()->clone() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char PartialCommand::getDataStructureType() const {
    return PartialCommand::ID_PARTIALCOMMAND; 
}

////////////////////////////////////////////////////////////////////////////////
const int PartialCommand::getCommandId() const {
    return commandId;
}

////////////////////////////////////////////////////////////////////////////////
int PartialCommand::getCommandId() {
    return commandId;
}

////////////////////////////////////////////////////////////////////////////////
void PartialCommand::setCommandId(int commandId ) {
    this->commandId = commandId;
}

////////////////////////////////////////////////////////////////////////////////
const std::vector<char> PartialCommand::getData() const {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
std::vector<char> PartialCommand::getData() {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
void PartialCommand::setData(std::vector<char> data ) {
    this->data = data;
}

