/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/ConsumerControlMarshaller.h>

#include <activemq/connector/openwire/commands/ConsumerControl.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* ConsumerControlMarshaller::createObject() const {
    return new ConsumerControl();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char ConsumerControlMarshaller::getDataStructureType() const {
    return ConsumerControl::ID_CONSUMERCONTROL;
}

///////////////////////////////////////////////////////////////////////////////
void ConsumerControlMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseCommandMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    ConsumerControl* info =
        dynamic_cast<ConsumerControl*>( dataStructure );
    info->setClose( bs->readBoolean() );
    info->setConsumerId( dynamic_cast< ConsumerId* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
    info->setPrefetch( dataIn->readInt() );
}

///////////////////////////////////////////////////////////////////////////////
int ConsumerControlMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    ConsumerControl* info =
        dynamic_cast<ConsumerControl*>( dataStructure );

    int rc = BaseCommandMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    bs->writeBoolean( info->isClose() );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConsumerId() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );

    return rc + 4;
}

///////////////////////////////////////////////////////////////////////////////
void ConsumerControlMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseCommandMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    ConsumerControl* info =
        dynamic_cast<ConsumerControl*>( dataStructure );
    bs->readBoolean();
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConsumerId() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
    dataOut->write( info->getPrefetch() );
}

///////////////////////////////////////////////////////////////////////////////
void ConsumerControlMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseCommandMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    ConsumerControl* info = 
        dynamic_cast<ConsumerControl*>( dataStructure );
    info->setClose( dataIn->readBoolean() );
   info->setConsumerId( dynamic_cast<ConsumerId* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
    info->setPrefetch( dataIn->readInt() );
}

///////////////////////////////////////////////////////////////////////////////
void ConsumerControlMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    ConsumerControl* info =
        dynamic_cast<ConsumerControl*>( dataStructure );
    BaseCommandMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    dataOut->write( info->isClose() );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConsumerId() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
    dataOut->write( info->getPrefetch() );
}

