/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/JournalTopicAckMarshaller.h>

#include <activemq/connector/openwire/commands/JournalTopicAck.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* JournalTopicAckMarshaller::createObject() const {
    return new JournalTopicAck();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char JournalTopicAckMarshaller::getDataStructureType() const {
    return JournalTopicAck::ID_JOURNALTOPICACK;
}

///////////////////////////////////////////////////////////////////////////////
void JournalTopicAckMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseDataStreamMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    JournalTopicAck* info =
        dynamic_cast<JournalTopicAck*>( dataStructure );
    info->setDestination( dynamic_cast< ActiveMQDestination* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
    info->setMessageId( dynamic_cast< MessageId* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
    info->setMessageSequenceId( TightUnmarshalLong( wireFormat, dataIn, bs ) );
    info->setSubscritionName( TightUnmarshalString( dataIn, bs ) );
    info->setClientId( TightUnmarshalString( dataIn, bs ) );
    info->setTransactionId( dynamic_cast< TransactionId* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
}

///////////////////////////////////////////////////////////////////////////////
int JournalTopicAckMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    JournalTopicAck* info =
        dynamic_cast<JournalTopicAck*>( dataStructure );

    int rc = BaseDataStreamMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getDestination() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getMessageId() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );
    rc += tightMarshalLong1( wireFormat, info->getMessageSequenceId(), bs );
    rc += tightMarshalString1( info->getSubscritionName(), bs );
    rc += tightMarshalString1( info->getClientId(), bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void JournalTopicAckMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseDataStreamMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    JournalTopicAck* info =
        dynamic_cast<JournalTopicAck*>( dataStructure );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getDestination() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getMessageId() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
    tightMarshalLong2( wireFormat, info->getMessageSequenceId(), dataOut, bs );
    tightMarshalString2( info->getSubscritionName(), dataOut, bs );
    tightMarshalString2( info->getClientId(), dataOut, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void JournalTopicAckMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseDataStreamMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    JournalTopicAck* info = 
        dynamic_cast<JournalTopicAck*>( dataStructure );
   info->setDestination( dynamic_cast<ActiveMQDestination* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
   info->setMessageId( dynamic_cast<MessageId* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
    info->setMessageSequenceId( looseUnmarshalLong( wireFormat, dataIn ) );
    info->setSubscritionName( looseUnmarshalString( dataIn ) );
    info->setClientId( looseUnmarshalString( dataIn ) );
   info->setTransactionId( dynamic_cast<TransactionId* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
}

///////////////////////////////////////////////////////////////////////////////
void JournalTopicAckMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    JournalTopicAck* info =
        dynamic_cast<JournalTopicAck*>( dataStructure );
    BaseDataStreamMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getDestination() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getMessageId() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
    looseMarshalLong( wireFormat, info->getMessageSequenceId(), dataOut );
    looseMarshalString( info->getSubscritionName(), dataOut );
    looseMarshalString( info->getClientId(), dataOut );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
}

